import 'package:osam/domain/state/base_state.dart';

// ignore: must_be_immutable
class StateWithNavigation extends BaseState<StateWithNavigation> {
  var routes = <String>[];
  StateWithNavigation({this.routes});

  void push(String route) => routes.add(route);

  void pushReplacement(String route) =>
      routes.replaceRange(routes.length - 1, routes.length, [route]);

  void pushAndRemoveUntil(String route) {
    routes.clear();
    routes.add(route);
  }

  void pop() => routes.removeLast();

  @override
  List<List<String>> get props => [routes];
}

// ignore: must_be_immutable
class TabStateWithNavigation extends BaseState<TabStateWithNavigation> {
  String currentTab;
  TabStateWithNavigation({this.currentTab});

  @override
  List<String> get props => [currentTab];
}
